
/*
 * Objective-C version of Squeak Morphic. Copyright (c) 1999 David Stes.
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: BooklikeMorph.h,v 1.3 1999/05/26 18:34:58 stes Exp $
 */

#ifndef __BOOKLIKEMORPH_H__

#include <AlignmentMorph.h>

@interface BooklikeMorph : AlignmentMorph
{
	id pageSize;
	id newPagePrototype;
}

/* class methods */

+ initialize;
+ turnOffSoundWhile:aBlock;

/* page controls */

- fewerPageControls;
- fullControlSpecs;
- hidePageControls;
- makePageControlsFrom:controlSpecs;
- shortControlSpecs;
- showPageControl;
- showPageControls:controlSpecs;

/* menu commands */

- addCustomMenuItems:aCustomMenu hand:aHandMorph;
- clearNewPagePrototype;
- firstPage;
- insertPage;
- sortPages;

/* misc */

- addBookMenuItemsTo:aCustomMenu hand:aHandMorph;
- currentPlayerDo:aBlock;
- pageSize;
- pageSize:aPoint;
- playPageFlipSound;
- playPageFlipSound:soundName;
- presentResultMorph:aMorph;

@end
 
#define __BOOKLIKEMORPH_H__
#endif

